
   FUNCTION CERO(TIME)
      REAL (KIND=8) CERO,TIME
      TIME=INT(TIME)
      CERO=0
      RETURN
      end function

   FUNCTION STIME(YEAR,MONTH,DAY,DHOUR,TIMEZONE,TIME)    
    Interface
      REAL (c_double) function timeset(a,b,c,d,e,f) &
      bind(C,name="timeset")
        use, intrinsic :: ISO_C_BINDING, only: c_int
        use, intrinsic :: ISO_C_BINDING, only: c_double
        INTEGER (c_int),intent(in),value ::a,b,c
        REAL (c_double),intent(in),value ::d,e,f
      end function timeset
      End Interface
      REAL (KIND=8) STIME
      REAL (KIND=8) YEAR, MONTH, DAY, DHOUR,  TIMEZONE, TIME
    
      REAL (KIND=8) DH
     
      INTEGER  YEARC, MONTHC, DAYC
            
      YEARC=INT(YEAR)
      MONTHC=INT(MONTH)
      DAYC=INT(DAY)

            
      !write (*,*) "begin timeset", YEAR, DHOUR, TIME
      DH = timeset (%VAL(YEARC),%VAL(MONTHC),%VAL(DAYC),%VAL(DHOUR),&
                     %VAL(TIMEZONE),%VAL(TIME))

      !write (*,*) "timeset", DH
      STIME=DH
     !write (*,*) STIME
     RETURN 
   end function




!   FUNCTION AATIME(DH2,TIME)    
!    Interface
!      REAL (c_double) function addtime(TIME) &
!      bind(C,name="timeadd")
!        use, intrinsic :: ISO_C_BINDING, only: c_int
!        use, intrinsic :: ISO_C_BINDING, only: c_double        
!        REAL (c_double),intent(in),value ::TIME
!      end function addtime
!      End Interface
!      REAL (KIND=8) AATIME, DH2, TIME, DH
!      
!      DH2=DH2+1
!      !write (*,*) "begin timeset", YEAR, DHOUR, TIME
!      DH = addtime (%VAL(TIME))
!
!      !write (*,*) "timeset", DH
!      AATIME=DH
!     !write (*,*) ATIME
!     RETURN 
!   end function
            
      


   FUNCTION GEOM(DHOUR,LATITUDE, &
      LONGITUDE,HEIGHT,PRESSURE,TEMPERATURE,SLOPEINCRESE, &
      OTROGIROCOLECTOR,METODOSLOPE,MODEL)
    
    Interface
      INTEGER (c_int) function geometry(g,h,i, j, k, l, m,n,o) &
      bind(C,name="geometry")
        use, intrinsic :: ISO_C_BINDING, only: c_int
        use, intrinsic :: ISO_C_BINDING, only: c_double     
        REAL (c_double),intent(in),value :: g,h,i,j,k,l,m
        INTEGER (c_int),intent(in),value :: n,o
      end function geometry
      End Interface
      REAL (KIND=8) GEOM, DHOUR
      REAL (KIND=8) LATITUDE, LONGITUDE, HEIGHT, PRESSURE, TEMPERATURE
      REAL (KIND=8) SLOPEINCRESE, OTROGIROCOLECTOR, METODOSLOPE,MODEL
      INTEGER N, O, NUMG
      DHOUR=DHOUR+1 !para que cambie y no proteste
      N=INT(METODOSLOPE)
      O=INT(MODEL)
 
      !write (*,*) "begin geometry"
      numG = geometry (%VAL(LATITUDE), &
         %VAL(LONGITUDE), %VAL(HEIGHT),%VAL(PRESSURE),%VAL(TEMPERATURE), &
        %VAL(SLOPEINCRESE), %VAL(OTROGIROCOLECTOR),%VAL(N),%VAL(O));

      !write (*,*) "NUMG after geometry", numG, "HORA", DHOUR
      GEOM=numG
      !write (*,*) SOLARGEOMETRY
     RETURN 
   end function



     FUNCTION RADIA(num,nubes,numfile,method)
      Interface
        REAL (c_double) function radiation(numI,nubesI,numfileI,methodI) &
        bind(C,name="radiation")
        use, intrinsic :: ISO_C_BINDING, only: c_int
        use, intrinsic :: ISO_C_BINDING, only: c_double
        IMPLICIT NONE
      INTEGER (c_int),intent(in),value ::  numI          
      REAL (c_double),intent(in),value :: nubesI
      INTEGER (c_int),intent(in),value :: numfileI,methodI
      End function radiation
      End Interface
  
      REAL (KIND=8) RADIA       
      REAL (KIND=8) num          
      REAL (KIND=8) nubes      
      REAL (KIND=8) numfile
      REAL (KIND=8) method
      REAL (KIND=8) SR
      INTEGER numC
      INTEGER numfileC
      INTEGER methodC     

      !CONSTANTE_SOLAR=1366.1  ! pasarla a c
      
      !write (*,*) "MET ", method
      methodC=INT(method)
      !write (*,*) "METC ", methodC
      
      numC=int(num)
      numfileC=int(numfile)
     
      SR= radiation(numC,nubes,numfileC,%VAL(methodC))
      !write (*,*) "SR",SR
      RADIA=SR
      
     RETURN 
   end function

      
      
  FUNCTION SCOVER(num,K,L,nv,abscolector, tipo, basura)
      Interface
       REAL (c_double) function cover(numI,KI,LI,naI,nvI,abscolectorI, &
        tipoI, bas)  bind(C,name="cover")
        use, intrinsic :: ISO_C_BINDING, only: c_int
        use, intrinsic :: ISO_C_BINDING, only: c_double
        IMPLICIT NONE
      INTEGER (c_int),intent(in),value ::  numI          
      REAL (c_double),intent(in),value :: KI,LI,naI,nvI,abscolectorI,bas
      INTEGER (c_int),intent(in),value :: tipoI
      End function cover
      End Interface
  
      REAL (KIND=8)  SCOVER,num, K,L,na,nv,abscolector,tipo,S, basura
      INTEGER tipoC, numC
            
      na=1.
      tipoC=INT(tipo)
      numC=INT(num)
      
      S= cover(%VAL(numC),%VAL(K),%VAL(L),%VAL(na),%VAL(nv), &
          %VAL(abscolector),%VAL(tipoC),%VAL(basura))
      write (*,*) "Sa   ",S
      SCOVER=S
      
     RETURN 
   end function      
      
  FUNCTION SABS(num,cover,basura)
      Interface
        REAL (c_double) function vidabs(numI,coverI, bas) &
          bind(C,name="vidabs")
        use, intrinsic :: ISO_C_BINDING, only: c_int
        use, intrinsic :: ISO_C_BINDING, only: c_double
        IMPLICIT NONE
        INTEGER (c_int),intent(in),value :: numI
        INTEGER (c_int),intent(in),value :: coverI
        REAL (c_double),intent(in),value :: bas        
      End function vidabs
      End Interface
  
      REAL (KIND=8)  SABS, num, cover, AS,basura
      INTEGER coverC,numC           
      coverC=INT(cover)
      numC=INT(num)
      AS= vidabs(%VAL(numC),%VAL(coverC), %VAL(basura))
      !write (*,*) "BASURA ",basura,"VID ",AS,"------------------------------------------------------------------------------"
      !write (*,*) "."
      SABS=AS
     RETURN 
   end function
      
